from ship import Ship
from gravityutil import *
import effects
import sound
from gravityweapon import *

class Player(GravityAcc, Ship):
   accrate = 0.1
   acc = Vector(0,0,0)
   preEffects = [effects.playerAccelThruster]
   health = 100
   explodeSize = 1200
   vel = Vector(0,0,0)
   color = Color(0,1,.5)
   radius = 5
   model = getModel('warthog3')
   deathNoiseList = [sound.getSound('bigboom')]
   
   def __init__(self):
      self.pos = Earth.pos + Vectorp(1.5*Earth.radius, uniform(-pi, pi))
      self.weapons = [CombatWaspTube(self), NukeTube(self)]
   
   def fire(self, enemies):
      for w in self.weapons:
         w.fire(self.pos+Vectorp(self.radius, self.orientation),
              self.vel, self.orientation, enemies)
   
   def getCollision(self, ships):
      if self.alive:
         for ship in ships:
            if isCollision(self, ship):
               collideShips(self, ship)
      for w in self.weapons:
         w.getCollision(ships)
   
   def drawTriangle(self):
      for w in self.weapons:
         w.drawTriangle()
      GravityAcc.drawTriangle(self)
   
player = Player()


# vim: set et sts=3 sw=3:
