from weaponbase import Weapon
from projectile import ScramShot
from gravityutil import *
from projectile import Bomb, ScramShot, Projectile
import sound
from ai import *

class GravityWeapon(Weapon):
   
   def __init__(self, ship, slow=False):
      self.ship = ship
      self.reload = timer.Timer(self.reload)
      
   def fire(self, pos, vel, angle, targets):
      if self.reload.ready():
         if sound.isSound and self.shotNoise:
            self.shotNoise.play()
         self += self.getProjectiles(pos.copy, vel.copy, angle, targets)
   
   def update(self):
      for p in self:
         p.update()
         p.move()
         if not p.alive:
            self.remove(p)
   
   def drawTriangle(self):
      for p in self:
         p.drawTriangle()

class CombatWaspTube(GravityWeapon):
   shotNoise = sound.getSound('laser3')
   reload = 300
   def getProjectiles(self, pos, vel, o, targets):
      return [CombatWasp(pos, vel, o, targets)]

class NukeTube(GravityWeapon):
   reload = 600
   shotNoise = sound.getSound('cannon')
   projectileSpeed = Bomb.speed
   def getProjectiles(self, pos, vel, o, targets):
      return [Nuke(pos, vel, o, self, targets)]


class CombatWasp(GravityAcc, ScramShot):
   turnSpeed = 0.09
   color = Color(1, 1, 0)
   def __init__(self, pos, vel, o, targets):
      self.pos = pos
      self.vel = vel
      self.orientation = o
      self.targets = targets
      self.target = closest(self.pos, targets)
      self.lifeTime = timer.Timer(9000)
      self.acc = Vectorp(self.accrate, self.orientation)
   def update(self):
      self.checkTarget()
#      if 0.1 < self.lifeTime.percReady() < 0.16:
#          self.vel.dir = self.orientation
#      else:
      self.acc.dir = self.orientation


class Nuke(GravityAcc, Bomb):
   color = Color(.4, .6, .5)
   speed = 3
   def __init__(self, pos, vel, o, weapon, targets):
      self.pos = pos
      self.vel = Vectorp(self.speed, o) + vel
      self.orientation = o
      self.acc = Vector(0,0,0)
      self.weapon = weapon
      self.targets = targets
      self.subBullets = 30
      self.Bullet = Triangle

class Triangle(GravityAcc, Projectile):
   color = Color(1, .7, 0)
   damage = 6.5
   speed = 2
   model = getModel('triangle')
   def __init__(self, pos, vel, o, targets):
      self.pos = pos
      self.vel = Vectorp(self.speed, o) + vel
      self.acc = Vector(0,0,0)
      self.orientation = o
      self.targets = targets

# vim: set et sts=3 sw=3:
