from util import *
import sound

class Weapon(list):
   shotNoise = False
   
   projectiles = property(lambda self: list(self))
   
   def __init__(self, ship, slow=False):
      self.ship = ship
      self.init()
      if slow:
         self.reload *= 2
      self.reload = timer.Timer(self.reload)
   
   def init(self):
      pass
   
   def fire(self, pos, angle, targets):
      if self.reload.ready():
         if sound.isSound and self.shotNoise:
            self.shotNoise.play()
         self += self.getProjectiles(pos, angle, ~self.ship.color, targets)
   
   def draw(self):
      for projectile in self:
         projectile.draw()
   
   def update(self):
      for p in self:
         p.update()
         p.move()
         if not p.onScreen() or not p.alive:
            self.remove(p)
   
   def getCollision(self, ships):
      for ship in ships:
         if not ship.alive or self.ship is ship:
            continue
         for projectile in self:
            if isCollision(ship, projectile):
               ship.lastHitBy = self.ship
               projectile.hit(ship)
               self.remove(projectile)

# vim: set et sts=3 sw=3:
